#!/bin/bash

# build conv2d_caffe model
python3 scripts/conv2d_caffe.py --target k230 --caffemodel models/conv2d_caffe/test.caffemodel  --prototxt models/conv2d_caffe/test.prototxt

# build image classfy model
python3 ./scripts/mbv2_tflite.py --target k230 --model models/mbv2.tflite --dataset CalibrationSet

# build object detect model
python3 ./scripts/yolov5s_onnx.py --target k230 --model models/yolov5s.onnx

# check simu
python3 scripts/yolov5s_onnx_simu.py --model models/yolov5s.onnx --model_input object_detect/data/input_fp32.bin --kmodel tmp/yolov5s_onnx/test.kmodel --kmodel_input object_detect/data/input_uint8.bin

# build door lock models
python3 ./scripts/mobile_retinaface.py --target k230 --model models/mobile_retinaface.onnx --dataset CalibrationSet
python3 ./scripts/mbv2_depth.py --target k230 --model models/mbv2.tflite --dataset CalibrationSet
python3 ./scripts/mbv2_ir.py --target k230 --model models/mbv2.tflite --dataset CalibrationSet
python3 ./scripts/mbface_depth.py --target k230 --model models/mbface.onnx --dataset CalibrationSet
python3 ./scripts/mbface_ir.py --target k230 --model models/mbface.onnx --dataset CalibrationSet