#ifndef _MODEL_H
#define _MODEL_H

#include <nncase/runtime/host_runtime_tensor.h>
#include <nncase/runtime/interpreter.h>
#include "util.h"

using namespace nncase;
using namespace nncase::runtime;
using namespace nncase::runtime::detail;

class Model
{
public:
    Model(const char *model_name, const char *kmodel_file);
    ~Model();
    void run(uintptr_t vaddr, uintptr_t paddr);
    std::string model_name() const;

protected:
    virtual void preprocess(uintptr_t vaddr, uintptr_t paddr) = 0;
    void kpu_run();
    virtual void postprocess() = 0;
    runtime_tensor input_tensor(size_t idx);
    void input_tensor(size_t idx, runtime_tensor &tensor);
    runtime_tensor output_tensor(size_t idx);

protected:
    runtime_tensor ai2d_out_tensor_;

private:
    interpreter interp_;
    std::string model_name_;
    std::vector<uint8_t> kmodel_;
};
#endif
