/* This file is generated by Maix3.TableGen at 2021/9/27 上午10:59:41 +08:00.
 *
 * Copyright 2019-2021 Canaan Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
#pragma once
#include <iostream>
#include <nncase/codegen/binary_writer.h>
#include <nncase/runtime/bitio.h>
#include <sstream>

namespace nncase::ir::k230
{
class gnne_fusion;
}
namespace nncase::runtime::k230
{

// Enums

enum class gp_register_t
{
    x0 = 0x00,
    x1 = 0x01,
    x2 = 0x02,
    x3 = 0x03,
    x4 = 0x04,
    x5 = 0x05,
    x6 = 0x06,
    x7 = 0x07,
    x8 = 0x08,
    x9 = 0x09,
    x10 = 0x0A,
    x11 = 0x0B,
    x12 = 0x0C,
    x13 = 0x0D,
    x14 = 0x0E,
    x15 = 0x0F,
    x16 = 0x10,
    x17 = 0x11,
    x18 = 0x12,
    x19 = 0x13,
    x20 = 0x14,
    x21 = 0x15,
    x22 = 0x16,
    x23 = 0x17,
    x24 = 0x18,
    x25 = 0x19,
    x26 = 0x1A,
    x27 = 0x1B,
    x28 = 0x1C,
    x29 = 0x1D,
    x30 = 0x1E,
    x31 = 0x1F,
};

std::ostream &operator<<(std::ostream &out, const gp_register_t &v);

enum class shape_register_t
{
    ss0 = 0x0,
    ss1 = 0x1,
    ss2 = 0x2,
    ss3 = 0x3,
    ss4 = 0x4,
    ss5 = 0x5,
    ss6 = 0x6,
    ss7 = 0x7,
};

std::ostream &operator<<(std::ostream &out, const shape_register_t &v);

enum class opcode_t
{
    lui = 0x02,
    auipc = 0x04,
    load = 0x06,
    store = 0x08,
    arithm = 0x0C,
    arithm_imm = 0x0E,
    branch = 0x10,
    jal = 0x12,
    jalr = 0x14,
    intr = 0x01,
    end = 0x03,
    fence = 0x05,
    fence_i = 0x07,
    ss_pack_shape = 0x40,
    ss_pack_stride = 0x42,
    ccr_decl = 0x41,
    ccr_set = 0x43,
    ccr_clr = 0x45,
    mmu_conf = 0x44,
    mmu_set_id = 0x49,
    l2_load_conf = 0x46,
    l2_store_conf = 0x4A,
    l2_load = 0x4C,
    l2_store = 0x4E,
    l2_load_w_conf = 0x48,
    l2_load_w = 0x57,
    dm_conf_broadcast = 0x4B,
    dm_conf = 0x50,
    dm_load_l1 = 0x52,
    dm_load_w = 0x54,
    dm_load_act0 = 0x56,
    dm_store_of = 0x58,
    pu_conf = 0x5A,
    pu_compute = 0x4D,
    pu_forward_psum = 0x5C,
    pu_pdp0_conf = 0x5E,
    pu_pdp0_compute = 0x4F,
    act0_conf = 0x60,
    act0_compute = 0x74,
    mfu_conf = 0x62,
    mfu_memcpy = 0x64,
    mfu_memset = 0x66,
    mfu_transpose = 0x68,
    mfu_pdp1_compute = 0x6A,
    mfu_act1_compute = 0x72,
    extrw = 0x16,
    extraw = 0x18,
    ai2d_compute = 0x51,
};

std::ostream &operator<<(std::ostream &out, const opcode_t &v);

enum class act0_conf_function_t
{
    act_src1_conf = 0x0,
};

std::ostream &operator<<(std::ostream &out, const act0_conf_function_t &v);

enum class pu_conf_function_t
{
    pu_fetchif_conf1 = 0x0,
    pu_fetchif_conf2 = 0x1,
    pu_fetchif_conf3 = 0x2,
    pu_fetchif_conf4 = 0x3,
    pu_fetchif_conf_deq = 0x4,
    pu_w_conf = 0x5,
    pu_of_conf1 = 0x6,
    pu_of_conf2 = 0x7,
    pu_compute_conf = 0x8,
};

std::ostream &operator<<(std::ostream &out, const pu_conf_function_t &v);

enum class pu_of_shift_mode_t
{
    none = 0x0,
    left_shift_4 = 0x1,
    right_shift_4 = 0x2,
};

std::ostream &operator<<(std::ostream &out, const pu_of_shift_mode_t &v);

enum class pu_compute_mode_t
{
    pu_mode_normal = 0x0,
    pu_mode_deconv = 0x1,
};

std::ostream &operator<<(std::ostream &out, const pu_compute_mode_t &v);

enum class pu_pdp0_conf_function_t
{
    pdp0_mode_conf = 0x0,
    pdp0_fetchif_conf1 = 0x1,
    pdp0_fetchif_conf2 = 0x2,
    pdp0_fetchif_conf3 = 0x3,
    pdp0_fetchif_conf4 = 0x4,
    pdp0_fetchif_conf_deq = 0x5,
    pdp0_w_conf = 0x6,
    pdp0_of_conf = 0x7,
};

std::ostream &operator<<(std::ostream &out, const pu_pdp0_conf_function_t &v);

enum class pu_pdp0_mode_t
{
    dw = 0x0,
    min = 0x1,
    max = 0x2,
    sum = 0x3,
    average = 0x4,
};

std::ostream &operator<<(std::ostream &out, const pu_pdp0_mode_t &v);

enum class dm_conf_function_t
{
    load_l1_conf = 0x0,
    load_w_conf = 0x1,
    load_w_conf_deq = 0x2,
    load_act_params = 0x3,
    store_of_conf = 0x4,
    load_w_conf2 = 0x5,
};

std::ostream &operator<<(std::ostream &out, const dm_conf_function_t &v);

enum class dm_load_w_dest_t
{
    pu = 0x0,
    pdp0 = 0x1,
};

std::ostream &operator<<(std::ostream &out, const dm_load_w_dest_t &v);

enum class act0_channel_t
{
    pu = 0x0,
    pdp0 = 0x1,
};

std::ostream &operator<<(std::ostream &out, const act0_channel_t &v);

enum class mfu_conf_function_t
{
    transpose_conf = 0x00,
    pdp1_conf1 = 0x01,
    pdp1_conf2 = 0x02,
    pdp1_conf3 = 0x03,
    pdp1_conf4 = 0x04,
    pdp1_conf_op_in = 0x05,
    pdp1_conf_deq = 0x06,
    pdp1_conf_quant = 0x07,
    act1_conf_stride = 0x08,
    act1_conf_src1 = 0x09,
    act1_conf_src2 = 0x0A,
    act1_conf_dest = 0x0B,
    act1_conf_deq = 0x0C,
    act1_conf_quant = 0x0D,
    act1_conf = 0x0E,
};

std::ostream &operator<<(std::ostream &out, const mfu_conf_function_t &v);

enum class mfu_trans_permute_t
{
    nchw = 0x00,
    ncwh = 0x01,
    nhcw = 0x02,
    nhwc = 0x03,
    nwch = 0x04,
    nwhc = 0x05,
    cnhw = 0x06,
    cnwh = 0x07,
    chnw = 0x08,
    chwn = 0x09,
    cwnh = 0x0A,
    cwhn = 0x0B,
    hncw = 0x0C,
    hnwc = 0x0D,
    hcnw = 0x0E,
    hcwn = 0x0F,
    hwnc = 0x10,
    hwcn = 0x11,
    wnch = 0x12,
    wnhc = 0x13,
    wcnh = 0x14,
    wchn = 0x15,
    whnc = 0x16,
    whcn = 0x17,
};

std::ostream &operator<<(std::ostream &out, const mfu_trans_permute_t &v);

enum class pu_output_dest_t
{
    psum = 0x0,
    act0 = 0x1,
};

std::ostream &operator<<(std::ostream &out, const pu_output_dest_t &v);

enum class arithmetic_imm_function_t
{
    addi = 0x0,
};

std::ostream &operator<<(std::ostream &out, const arithmetic_imm_function_t &v);

enum class arithmetic_function_t
{
    add = 0x00,
    sub = 0x01,
    mul = 0x02,
    div = 0x03,
    divu = 0x04,
    rem = 0x05,
    remu = 0x06,
};

std::ostream &operator<<(std::ostream &out, const arithmetic_function_t &v);

enum class branch_function_t
{
    beq = 0x0,
    bne = 0x1,
    blt = 0x2,
    bltu = 0x3,
    bge = 0x4,
    bgeu = 0x5,
};

std::ostream &operator<<(std::ostream &out, const branch_function_t &v);

enum class load_function_t
{
    lw = 0x0,
    lh = 0x1,
    lhu = 0x2,
    lb = 0x3,
    lbu = 0x4,
};

std::ostream &operator<<(std::ostream &out, const load_function_t &v);

enum class store_function_t
{
    sw = 0x0,
    sh = 0x1,
    sb = 0x2,
};

std::ostream &operator<<(std::ostream &out, const store_function_t &v);

enum class ddr_datatype_t
{
    i8 = 0x0,
    fp16 = 0x1,
    fp32 = 0x2,
    i4 = 0x3,
    i6 = 0x4,
    i16 = 0x5,
};

std::ostream &operator<<(std::ostream &out, const ddr_datatype_t &v);

enum class l2_datatype_t
{
    i8 = 0x0,
    fp16 = 0x1,
    i16 = 0x2,
};

std::ostream &operator<<(std::ostream &out, const l2_datatype_t &v);

enum class act0_output_dest_t
{
    psum = 0x0,
    dm = 0x1,
    psum_dm = 0x2,
};

std::ostream &operator<<(std::ostream &out, const act0_output_dest_t &v);

enum class act_output_type_t
{
    u8 = 0x0,
    i8 = 0x1,
    fp16 = 0x2,
    i16 = 0x3,
};

std::ostream &operator<<(std::ostream &out, const act_output_type_t &v);

enum class act1_source_type_t
{
    l2 = 0x0,
    psum = 0x1,
};

std::ostream &operator<<(std::ostream &out, const act1_source_type_t &v);

enum class l1_type_t
{
    if_ = 0x0,
    w = 0x1,
    psum = 0x2,
};

std::ostream &operator<<(std::ostream &out, const l1_type_t &v);

enum class quant_type_t
{
    disable = 0x0,
    u8 = 0x1,
    i8 = 0x2,
    i16 = 0x3,
};

std::ostream &operator<<(std::ostream &out, const quant_type_t &v);

enum class sparcity_t
{
    dense = 0x0,
    sparse = 0x1,
};

std::ostream &operator<<(std::ostream &out, const sparcity_t &v);

enum class compression_t
{
    uncompressed = 0x0,
    compressed = 0x1,
};

std::ostream &operator<<(std::ostream &out, const compression_t &v);

enum class glb_load_store_function_t
{
    load = 0x0,
    store = 0x1,
};

std::ostream &operator<<(std::ostream &out, const glb_load_store_function_t &v);

enum class pdp_function_t
{
    min = 0x0,
    max = 0x1,
    average = 0x2,
    sum = 0x3,
};

std::ostream &operator<<(std::ostream &out, const pdp_function_t &v);

enum class mfu_act1_function_t
{
    add = 0x0,
    mul = 0x1,
};

std::ostream &operator<<(std::ostream &out, const mfu_act1_function_t &v);

constexpr inline gp_register_t unused_gp_reg = gp_register_t::x0;

namespace isa
{
    struct gnne_instruction_t
    {
        virtual opcode_t op_code() const = 0;
        virtual void serialize(binary_writer &writer) const = 0;
        virtual void to_string(std::ostream &out) const = 0;
        std::string to_string() const;
        virtual ~gnne_instruction_t() = default;
        std::tuple<nncase::ir::k230::gnne_fusion *, std::string> binding_gnne_fusion_info;
        uint64_t ddr_size;
    };

    std::ostream &operator<<(std::ostream &out, const gnne_instruction_t &c);

    // Instructions

    struct lui_t : public gnne_instruction_t
    {
        opcode_t opcode;
        gp_register_t rd;
        uint32_t imm;

        lui_t(default_init_t) noexcept { }
        explicit lui_t(gp_register_t rd, uint32_t imm) noexcept
            : opcode(opcode_t::lui), rd(rd), imm(imm)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const lui_t &inst);

    struct auipc_t : public gnne_instruction_t
    {
        opcode_t opcode;
        gp_register_t rd;
        uint32_t imm;

        auipc_t(default_init_t) noexcept { }
        explicit auipc_t(gp_register_t rd, uint32_t imm) noexcept
            : opcode(opcode_t::auipc), rd(rd), imm(imm)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const auipc_t &inst);

    struct addi_t : public gnne_instruction_t
    {
        opcode_t opcode;
        gp_register_t rd;
        gp_register_t rs;
        arithmetic_imm_function_t funct5;
        uint32_t imm;

        addi_t(default_init_t) noexcept { }
        explicit addi_t(gp_register_t rd, gp_register_t rs, uint32_t imm) noexcept
            : opcode(opcode_t::arithm_imm), rd(rd), rs(rs), funct5(arithmetic_imm_function_t::addi), imm(imm)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const addi_t &inst);

    struct add_t : public gnne_instruction_t
    {
        opcode_t opcode;
        gp_register_t rd;
        gp_register_t rs1;
        arithmetic_function_t funct5;
        gp_register_t rs2;
        uint32_t reserved0;

        add_t(default_init_t) noexcept { }
        explicit add_t(gp_register_t rd, gp_register_t rs1, gp_register_t rs2) noexcept
            : opcode(opcode_t::arithm), rd(rd), rs1(rs1), funct5(arithmetic_function_t::add), rs2(rs2), reserved0(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const add_t &inst);

    struct sub_t : public gnne_instruction_t
    {
        opcode_t opcode;
        gp_register_t rd;
        gp_register_t rs1;
        arithmetic_function_t funct5;
        gp_register_t rs2;
        uint32_t reserved0;

        sub_t(default_init_t) noexcept { }
        explicit sub_t(gp_register_t rd, gp_register_t rs1, gp_register_t rs2) noexcept
            : opcode(opcode_t::arithm), rd(rd), rs1(rs1), funct5(arithmetic_function_t::sub), rs2(rs2), reserved0(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const sub_t &inst);

    struct mul_t : public gnne_instruction_t
    {
        opcode_t opcode;
        gp_register_t rd;
        gp_register_t rs1;
        arithmetic_function_t funct5;
        gp_register_t rs2;
        uint32_t reserved0;

        mul_t(default_init_t) noexcept { }
        explicit mul_t(gp_register_t rd, gp_register_t rs1, gp_register_t rs2) noexcept
            : opcode(opcode_t::arithm), rd(rd), rs1(rs1), funct5(arithmetic_function_t::mul), rs2(rs2), reserved0(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const mul_t &inst);

    struct div_t : public gnne_instruction_t
    {
        opcode_t opcode;
        gp_register_t rd;
        gp_register_t rs1;
        arithmetic_function_t funct5;
        gp_register_t rs2;
        uint32_t reserved0;

        div_t(default_init_t) noexcept { }
        explicit div_t(gp_register_t rd, gp_register_t rs1, gp_register_t rs2) noexcept
            : opcode(opcode_t::arithm), rd(rd), rs1(rs1), funct5(arithmetic_function_t::div), rs2(rs2), reserved0(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const div_t &inst);

    struct divu_t : public gnne_instruction_t
    {
        opcode_t opcode;
        gp_register_t rd;
        gp_register_t rs1;
        arithmetic_function_t funct5;
        gp_register_t rs2;
        uint32_t reserved0;

        divu_t(default_init_t) noexcept { }
        explicit divu_t(gp_register_t rd, gp_register_t rs1, gp_register_t rs2) noexcept
            : opcode(opcode_t::arithm), rd(rd), rs1(rs1), funct5(arithmetic_function_t::divu), rs2(rs2), reserved0(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const divu_t &inst);

    struct rem_t : public gnne_instruction_t
    {
        opcode_t opcode;
        gp_register_t rd;
        gp_register_t rs1;
        arithmetic_function_t funct5;
        gp_register_t rs2;
        uint32_t reserved0;

        rem_t(default_init_t) noexcept { }
        explicit rem_t(gp_register_t rd, gp_register_t rs1, gp_register_t rs2) noexcept
            : opcode(opcode_t::arithm), rd(rd), rs1(rs1), funct5(arithmetic_function_t::rem), rs2(rs2), reserved0(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const rem_t &inst);

    struct remu_t : public gnne_instruction_t
    {
        opcode_t opcode;
        gp_register_t rd;
        gp_register_t rs1;
        arithmetic_function_t funct5;
        gp_register_t rs2;
        uint32_t reserved0;

        remu_t(default_init_t) noexcept { }
        explicit remu_t(gp_register_t rd, gp_register_t rs1, gp_register_t rs2) noexcept
            : opcode(opcode_t::arithm), rd(rd), rs1(rs1), funct5(arithmetic_function_t::remu), rs2(rs2), reserved0(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const remu_t &inst);

    struct lw_t : public gnne_instruction_t
    {
        opcode_t opcode;
        gp_register_t rd;
        gp_register_t rs;
        load_function_t funct3;
        uint32_t offset;

        lw_t(default_init_t) noexcept { }
        explicit lw_t(gp_register_t rd, gp_register_t rs, uint32_t offset) noexcept
            : opcode(opcode_t::load), rd(rd), rs(rs), funct3(load_function_t::lw), offset(offset)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const lw_t &inst);

    struct lh_t : public gnne_instruction_t
    {
        opcode_t opcode;
        gp_register_t rd;
        gp_register_t rs;
        load_function_t funct3;
        uint32_t offset;

        lh_t(default_init_t) noexcept { }
        explicit lh_t(gp_register_t rd, gp_register_t rs, uint32_t offset) noexcept
            : opcode(opcode_t::load), rd(rd), rs(rs), funct3(load_function_t::lh), offset(offset)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const lh_t &inst);

    struct lhu_t : public gnne_instruction_t
    {
        opcode_t opcode;
        gp_register_t rd;
        gp_register_t rs;
        load_function_t funct3;
        uint32_t offset;

        lhu_t(default_init_t) noexcept { }
        explicit lhu_t(gp_register_t rd, gp_register_t rs, uint32_t offset) noexcept
            : opcode(opcode_t::load), rd(rd), rs(rs), funct3(load_function_t::lhu), offset(offset)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const lhu_t &inst);

    struct lb_t : public gnne_instruction_t
    {
        opcode_t opcode;
        gp_register_t rd;
        gp_register_t rs;
        load_function_t funct3;
        uint32_t offset;

        lb_t(default_init_t) noexcept { }
        explicit lb_t(gp_register_t rd, gp_register_t rs, uint32_t offset) noexcept
            : opcode(opcode_t::load), rd(rd), rs(rs), funct3(load_function_t::lb), offset(offset)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const lb_t &inst);

    struct lbu_t : public gnne_instruction_t
    {
        opcode_t opcode;
        gp_register_t rd;
        gp_register_t rs;
        load_function_t funct3;
        uint32_t offset;

        lbu_t(default_init_t) noexcept { }
        explicit lbu_t(gp_register_t rd, gp_register_t rs, uint32_t offset) noexcept
            : opcode(opcode_t::load), rd(rd), rs(rs), funct3(load_function_t::lbu), offset(offset)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const lbu_t &inst);

    struct sw_t : public gnne_instruction_t
    {
        opcode_t opcode;
        gp_register_t rd;
        gp_register_t rs;
        store_function_t funct3;
        uint32_t offset;

        sw_t(default_init_t) noexcept { }
        explicit sw_t(gp_register_t rd, gp_register_t rs, uint32_t offset) noexcept
            : opcode(opcode_t::store), rd(rd), rs(rs), funct3(store_function_t::sw), offset(offset)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const sw_t &inst);

    struct sh_t : public gnne_instruction_t
    {
        opcode_t opcode;
        gp_register_t rd;
        gp_register_t rs;
        store_function_t funct3;
        uint32_t offset;

        sh_t(default_init_t) noexcept { }
        explicit sh_t(gp_register_t rd, gp_register_t rs, uint32_t offset) noexcept
            : opcode(opcode_t::store), rd(rd), rs(rs), funct3(store_function_t::sh), offset(offset)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const sh_t &inst);

    struct sb_t : public gnne_instruction_t
    {
        opcode_t opcode;
        gp_register_t rd;
        gp_register_t rs;
        store_function_t funct3;
        uint32_t offset;

        sb_t(default_init_t) noexcept { }
        explicit sb_t(gp_register_t rd, gp_register_t rs, uint32_t offset) noexcept
            : opcode(opcode_t::store), rd(rd), rs(rs), funct3(store_function_t::sb), offset(offset)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const sb_t &inst);

    struct beq_t : public gnne_instruction_t
    {
        opcode_t opcode;
        gp_register_t rs1;
        gp_register_t rs2;
        branch_function_t funct3;
        uint32_t offset;

        beq_t(default_init_t) noexcept { }
        explicit beq_t(gp_register_t rs1, gp_register_t rs2, uint32_t offset) noexcept
            : opcode(opcode_t::branch), rs1(rs1), rs2(rs2), funct3(branch_function_t::beq), offset(offset)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const beq_t &inst);

    struct bne_t : public gnne_instruction_t
    {
        opcode_t opcode;
        gp_register_t rs1;
        gp_register_t rs2;
        branch_function_t funct3;
        uint32_t offset;

        bne_t(default_init_t) noexcept { }
        explicit bne_t(gp_register_t rs1, gp_register_t rs2, uint32_t offset) noexcept
            : opcode(opcode_t::branch), rs1(rs1), rs2(rs2), funct3(branch_function_t::bne), offset(offset)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const bne_t &inst);

    struct blt_t : public gnne_instruction_t
    {
        opcode_t opcode;
        gp_register_t rs1;
        gp_register_t rs2;
        branch_function_t funct3;
        uint32_t offset;

        blt_t(default_init_t) noexcept { }
        explicit blt_t(gp_register_t rs1, gp_register_t rs2, uint32_t offset) noexcept
            : opcode(opcode_t::branch), rs1(rs1), rs2(rs2), funct3(branch_function_t::blt), offset(offset)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const blt_t &inst);

    struct bltu_t : public gnne_instruction_t
    {
        opcode_t opcode;
        gp_register_t rs1;
        gp_register_t rs2;
        branch_function_t funct3;
        uint32_t offset;

        bltu_t(default_init_t) noexcept { }
        explicit bltu_t(gp_register_t rs1, gp_register_t rs2, uint32_t offset) noexcept
            : opcode(opcode_t::branch), rs1(rs1), rs2(rs2), funct3(branch_function_t::bltu), offset(offset)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const bltu_t &inst);

    struct bge_t : public gnne_instruction_t
    {
        opcode_t opcode;
        gp_register_t rs1;
        gp_register_t rs2;
        branch_function_t funct3;
        uint32_t offset;

        bge_t(default_init_t) noexcept { }
        explicit bge_t(gp_register_t rs1, gp_register_t rs2, uint32_t offset) noexcept
            : opcode(opcode_t::branch), rs1(rs1), rs2(rs2), funct3(branch_function_t::bge), offset(offset)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const bge_t &inst);

    struct bgeu_t : public gnne_instruction_t
    {
        opcode_t opcode;
        gp_register_t rs1;
        gp_register_t rs2;
        branch_function_t funct3;
        uint32_t offset;

        bgeu_t(default_init_t) noexcept { }
        explicit bgeu_t(gp_register_t rs1, gp_register_t rs2, uint32_t offset) noexcept
            : opcode(opcode_t::branch), rs1(rs1), rs2(rs2), funct3(branch_function_t::bgeu), offset(offset)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const bgeu_t &inst);

    struct jal_t : public gnne_instruction_t
    {
        opcode_t opcode;
        gp_register_t rd;
        uint32_t offset;

        jal_t(default_init_t) noexcept { }
        explicit jal_t(gp_register_t rd, uint32_t offset) noexcept
            : opcode(opcode_t::jal), rd(rd), offset(offset)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const jal_t &inst);

    struct jalr_t : public gnne_instruction_t
    {
        opcode_t opcode;
        gp_register_t rd;
        gp_register_t rs;
        uint32_t reserved0;
        uint32_t offset;

        jalr_t(default_init_t) noexcept { }
        explicit jalr_t(gp_register_t rd, gp_register_t rs, uint32_t offset) noexcept
            : opcode(opcode_t::jalr), rd(rd), rs(rs), reserved0(0), offset(offset)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const jalr_t &inst);

    struct intr_t : public gnne_instruction_t
    {
        opcode_t opcode;
        gp_register_t rs;
        uint32_t reserved0;

        intr_t(default_init_t) noexcept { }
        explicit intr_t(gp_register_t rs) noexcept
            : opcode(opcode_t::intr), rs(rs), reserved0(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const intr_t &inst);

    struct end_t : public gnne_instruction_t
    {
        opcode_t opcode;
        gp_register_t rs;
        uint32_t reserved0;

        end_t(default_init_t) noexcept { }
        explicit end_t(gp_register_t rs) noexcept
            : opcode(opcode_t::end), rs(rs), reserved0(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const end_t &inst);

    struct fence_t : public gnne_instruction_t
    {
        opcode_t opcode;
        uint32_t reserved0;

        fence_t(default_init_t) noexcept { }
        explicit fence_t() noexcept
            : opcode(opcode_t::fence), reserved0(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const fence_t &inst);

    struct fence_i_t : public gnne_instruction_t
    {
        opcode_t opcode;
        uint32_t reserved0;

        fence_i_t(default_init_t) noexcept { }
        explicit fence_i_t() noexcept
            : opcode(opcode_t::fence_i), reserved0(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const fence_i_t &inst);

    struct ccr_decl_t : public gnne_instruction_t
    {
        opcode_t opcode;
        gp_register_t rnum;
        uint32_t reserved0;

        ccr_decl_t(default_init_t) noexcept { }
        explicit ccr_decl_t(gp_register_t rnum) noexcept
            : opcode(opcode_t::ccr_decl), rnum(rnum), reserved0(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const ccr_decl_t &inst);

    struct ccr_set_t : public gnne_instruction_t
    {
        opcode_t opcode;
        uint32_t ccr;
        uint32_t value;

        ccr_set_t(default_init_t) noexcept { }
        explicit ccr_set_t(uint32_t ccr, uint32_t value) noexcept
            : opcode(opcode_t::ccr_set), ccr(ccr), value(value)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const ccr_set_t &inst);

    struct ccr_clr_t : public gnne_instruction_t
    {
        opcode_t opcode;
        uint32_t ccr;
        uint32_t reserved0;

        ccr_clr_t(default_init_t) noexcept { }
        explicit ccr_clr_t(uint32_t ccr) noexcept
            : opcode(opcode_t::ccr_clr), ccr(ccr), reserved0(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const ccr_clr_t &inst);

    struct mmu_conf_t : public gnne_instruction_t
    {
        opcode_t opcode;
        gp_register_t rstart;
        gp_register_t rdepth;
        uint32_t mmu_id;
        uint32_t reserved0;

        mmu_conf_t(default_init_t) noexcept { }
        explicit mmu_conf_t(gp_register_t rstart, gp_register_t rdepth, uint32_t mmu_id) noexcept
            : opcode(opcode_t::mmu_conf), rstart(rstart), rdepth(rdepth), mmu_id(mmu_id), reserved0(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const mmu_conf_t &inst);

    struct mmu_setid_t : public gnne_instruction_t
    {
        opcode_t opcode;
        gp_register_t rd;
        uint32_t mmu_id;

        mmu_setid_t(default_init_t) noexcept { }
        explicit mmu_setid_t(gp_register_t rd, uint32_t mmu_id) noexcept
            : opcode(opcode_t::mmu_set_id), rd(rd), mmu_id(mmu_id)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const mmu_setid_t &inst);

    struct ss_pack_shape_t : public gnne_instruction_t
    {
        opcode_t opcode;
        gp_register_t rn;
        gp_register_t rc;
        gp_register_t rh;
        gp_register_t rw;
        shape_register_t rss;
        uint32_t reserved0;

        ss_pack_shape_t(default_init_t) noexcept { }
        explicit ss_pack_shape_t(gp_register_t rn, gp_register_t rc, gp_register_t rh, gp_register_t rw, shape_register_t rss) noexcept
            : opcode(opcode_t::ss_pack_shape), rn(rn), rc(rc), rh(rh), rw(rw), rss(rss), reserved0(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const ss_pack_shape_t &inst);

    struct ss_pack_stride_t : public gnne_instruction_t
    {
        opcode_t opcode;
        gp_register_t rn;
        gp_register_t rc;
        gp_register_t rh;
        uint32_t reserved0;
        shape_register_t rss;
        uint32_t reserved1;

        ss_pack_stride_t(default_init_t) noexcept { }
        explicit ss_pack_stride_t(gp_register_t rn, gp_register_t rc, gp_register_t rh, shape_register_t rss) noexcept
            : opcode(opcode_t::ss_pack_stride), rn(rn), rc(rc), rh(rh), reserved0(0), rss(rss), reserved1(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const ss_pack_stride_t &inst);

    struct l2_load_conf_t : public gnne_instruction_t
    {
        opcode_t opcode;
        shape_register_t rstride_d;
        shape_register_t rstride_s;
        l2_datatype_t l2_datatype;
        ddr_datatype_t ddr_datatype;
        uint32_t reserved0;

        l2_load_conf_t(default_init_t) noexcept { }
        explicit l2_load_conf_t(shape_register_t rstride_d, shape_register_t rstride_s, l2_datatype_t l2_datatype, ddr_datatype_t ddr_datatype) noexcept
            : opcode(opcode_t::l2_load_conf), rstride_d(rstride_d), rstride_s(rstride_s), l2_datatype(l2_datatype), ddr_datatype(ddr_datatype), reserved0(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const l2_load_conf_t &inst);

    struct l2_load_w_conf_t : public gnne_instruction_t
    {
        opcode_t opcode;
        gp_register_t rlen_compressed;
        gp_register_t rlen_decompressed;
        l2_datatype_t l2_datatype;
        ddr_datatype_t ddr_datatype;
        uint32_t enable_decompress;
        uint32_t reserved0;

        l2_load_w_conf_t(default_init_t) noexcept { }
        explicit l2_load_w_conf_t(gp_register_t rlen_compressed, gp_register_t rlen_decompressed, l2_datatype_t l2_datatype, ddr_datatype_t ddr_datatype, uint32_t enable_decompress) noexcept
            : opcode(opcode_t::l2_load_w_conf), rlen_compressed(rlen_compressed), rlen_decompressed(rlen_decompressed), l2_datatype(l2_datatype), ddr_datatype(ddr_datatype), enable_decompress(enable_decompress), reserved0(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const l2_load_w_conf_t &inst);

    struct l2_load_w_t : public gnne_instruction_t
    {
        opcode_t opcode;
        gp_register_t raddr_d;
        gp_register_t raddr_s;
        gp_register_t rvalid_c_num;
        uint32_t reserved0;

        l2_load_w_t(default_init_t) noexcept { }
        explicit l2_load_w_t(gp_register_t raddr_d, gp_register_t raddr_s, gp_register_t rvalid_c_num) noexcept
            : opcode(opcode_t::l2_load_w), raddr_d(raddr_d), raddr_s(raddr_s), rvalid_c_num(rvalid_c_num), reserved0(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const l2_load_w_t &inst);

    struct l2_store_conf_t : public gnne_instruction_t
    {
        opcode_t opcode;
        shape_register_t rstride_d;
        shape_register_t rstride_s;
        l2_datatype_t l2_datatype;
        ddr_datatype_t ddr_datatype;
        uint32_t reserved0;

        l2_store_conf_t(default_init_t) noexcept { }
        explicit l2_store_conf_t(shape_register_t rstride_d, shape_register_t rstride_s, l2_datatype_t l2_datatype, ddr_datatype_t ddr_datatype) noexcept
            : opcode(opcode_t::l2_store_conf), rstride_d(rstride_d), rstride_s(rstride_s), l2_datatype(l2_datatype), ddr_datatype(ddr_datatype), reserved0(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const l2_store_conf_t &inst);

    struct l2_load_t : public gnne_instruction_t
    {
        opcode_t opcode;
        gp_register_t raddr_d;
        gp_register_t raddr_s;
        shape_register_t rshape;
        uint32_t reserved0;

        l2_load_t(default_init_t) noexcept { }
        explicit l2_load_t(gp_register_t raddr_d, gp_register_t raddr_s, shape_register_t rshape) noexcept
            : opcode(opcode_t::l2_load), raddr_d(raddr_d), raddr_s(raddr_s), rshape(rshape), reserved0(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const l2_load_t &inst);

    struct l2_store_t : public gnne_instruction_t
    {
        opcode_t opcode;
        gp_register_t raddr_d;
        gp_register_t raddr_s;
        shape_register_t rshape;
        uint32_t reserved0;

        l2_store_t(default_init_t) noexcept { }
        explicit l2_store_t(gp_register_t raddr_d, gp_register_t raddr_s, shape_register_t rshape) noexcept
            : opcode(opcode_t::l2_store), raddr_d(raddr_d), raddr_s(raddr_s), rshape(rshape), reserved0(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const l2_store_t &inst);

    struct dm_conf_broadcast_t : public gnne_instruction_t
    {
        opcode_t opcode;
        uint32_t tcu_id;
        uint32_t broadcast_if;
        uint32_t broadcast_w;
        uint32_t psum_cascade;
        uint32_t reserved0;

        dm_conf_broadcast_t(default_init_t) noexcept { }
        explicit dm_conf_broadcast_t(uint32_t tcu_id, uint32_t broadcast_if, uint32_t broadcast_w, uint32_t psum_cascade) noexcept
            : opcode(opcode_t::dm_conf_broadcast), tcu_id(tcu_id), broadcast_if(broadcast_if), broadcast_w(broadcast_w), psum_cascade(psum_cascade), reserved0(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const dm_conf_broadcast_t &inst);

    struct dm_load_l1_conf_t : public gnne_instruction_t
    {
        opcode_t opcode;
        uint32_t tcu_id;
        uint32_t pu_id;
        dm_conf_function_t funct4;
        shape_register_t rstride_s;
        l2_datatype_t datatype;
        l1_type_t l1_type;
        uint32_t reserved0;

        dm_load_l1_conf_t(default_init_t) noexcept { }
        explicit dm_load_l1_conf_t(uint32_t tcu_id, uint32_t pu_id, shape_register_t rstride_s, l2_datatype_t datatype, l1_type_t l1_type) noexcept
            : opcode(opcode_t::dm_conf), tcu_id(tcu_id), pu_id(pu_id), funct4(dm_conf_function_t::load_l1_conf), rstride_s(rstride_s), datatype(datatype), l1_type(l1_type), reserved0(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const dm_load_l1_conf_t &inst);

    struct dm_load_w_conf_t : public gnne_instruction_t
    {
        opcode_t opcode;
        uint32_t tcu_id;
        uint32_t pu_id;
        dm_conf_function_t funct4;
        uint32_t kernel_h;
        uint32_t kernel_w;
        gp_register_t rstride_oc;

        dm_load_w_conf_t(default_init_t) noexcept { }
        explicit dm_load_w_conf_t(uint32_t tcu_id, uint32_t pu_id, uint32_t kernel_h, uint32_t kernel_w, gp_register_t rstride_oc) noexcept
            : opcode(opcode_t::dm_conf), tcu_id(tcu_id), pu_id(pu_id), funct4(dm_conf_function_t::load_w_conf), kernel_h(kernel_h), kernel_w(kernel_w), rstride_oc(rstride_oc)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const dm_load_w_conf_t &inst);

    struct dm_load_w_conf2_t : public gnne_instruction_t
    {
        opcode_t opcode;
        uint32_t tcu_id;
        uint32_t pu_id;
        dm_conf_function_t funct4;
        gp_register_t rgroups;
        gp_register_t rgoc;
        uint32_t reserved0;

        dm_load_w_conf2_t(default_init_t) noexcept { }
        explicit dm_load_w_conf2_t(uint32_t tcu_id, uint32_t pu_id, gp_register_t rgroups, gp_register_t rgoc) noexcept
            : opcode(opcode_t::dm_conf), tcu_id(tcu_id), pu_id(pu_id), funct4(dm_conf_function_t::load_w_conf2), rgroups(rgroups), rgoc(rgoc), reserved0(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const dm_load_w_conf2_t &inst);

    struct dm_load_w_conf_deq_t : public gnne_instruction_t
    {
        opcode_t opcode;
        uint32_t tcu_id;
        uint32_t pu_id;
        dm_conf_function_t funct4;
        quant_type_t quant_type;
        uint32_t reserved0;

        dm_load_w_conf_deq_t(default_init_t) noexcept { }
        explicit dm_load_w_conf_deq_t(uint32_t tcu_id, uint32_t pu_id, quant_type_t quant_type) noexcept
            : opcode(opcode_t::dm_conf), tcu_id(tcu_id), pu_id(pu_id), funct4(dm_conf_function_t::load_w_conf_deq), quant_type(quant_type), reserved0(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const dm_load_w_conf_deq_t &inst);

    struct dm_store_of_conf_t : public gnne_instruction_t
    {
        opcode_t opcode;
        uint32_t tcu_id;
        uint32_t pu_id;
        dm_conf_function_t funct4;
        shape_register_t rstride_d;
        l2_datatype_t datatype;
        uint32_t reserved0;

        dm_store_of_conf_t(default_init_t) noexcept { }
        explicit dm_store_of_conf_t(uint32_t tcu_id, uint32_t pu_id, shape_register_t rstride_d, l2_datatype_t datatype) noexcept
            : opcode(opcode_t::dm_conf), tcu_id(tcu_id), pu_id(pu_id), funct4(dm_conf_function_t::store_of_conf), rstride_d(rstride_d), datatype(datatype), reserved0(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const dm_store_of_conf_t &inst);

    struct dm_load_l1_t : public gnne_instruction_t
    {
        opcode_t opcode;
        uint32_t tcu_id;
        uint32_t pu_id;
        gp_register_t raddr_s;
        gp_register_t rhtoc_window;
        shape_register_t rshape;
        l1_type_t l1_type;
        uint32_t reserved0;

        dm_load_l1_t(default_init_t) noexcept { }
        explicit dm_load_l1_t(uint32_t tcu_id, uint32_t pu_id, gp_register_t raddr_s, gp_register_t rhtoc_window, shape_register_t rshape, l1_type_t l1_type) noexcept
            : opcode(opcode_t::dm_load_l1), tcu_id(tcu_id), pu_id(pu_id), raddr_s(raddr_s), rhtoc_window(rhtoc_window), rshape(rshape), l1_type(l1_type), reserved0(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const dm_load_l1_t &inst);

    struct dm_load_w_t : public gnne_instruction_t
    {
        opcode_t opcode;
        uint32_t tcu_id;
        uint32_t pu_id;
        gp_register_t raddr_s;
        gp_register_t raddr_bw;
        shape_register_t r_iochannels;
        dm_load_w_dest_t dest_type;
        uint32_t reserved0;

        dm_load_w_t(default_init_t) noexcept { }
        explicit dm_load_w_t(uint32_t tcu_id, uint32_t pu_id, gp_register_t raddr_s, gp_register_t raddr_bw, shape_register_t r_iochannels, dm_load_w_dest_t dest_type) noexcept
            : opcode(opcode_t::dm_load_w), tcu_id(tcu_id), pu_id(pu_id), raddr_s(raddr_s), raddr_bw(raddr_bw), r_iochannels(r_iochannels), dest_type(dest_type), reserved0(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const dm_load_w_t &inst);

    struct dm_load_act0_t : public gnne_instruction_t
    {
        opcode_t opcode;
        uint32_t tcu_id;
        uint32_t pu_id;
        gp_register_t raddr_s;
        gp_register_t rlen;
        act0_channel_t dest_channel;
        uint32_t is_by_channel;
        uint32_t reserved0;

        dm_load_act0_t(default_init_t) noexcept { }
        explicit dm_load_act0_t(uint32_t tcu_id, uint32_t pu_id, gp_register_t raddr_s, gp_register_t rlen, act0_channel_t dest_channel, uint32_t is_by_channel) noexcept
            : opcode(opcode_t::dm_load_act0), tcu_id(tcu_id), pu_id(pu_id), raddr_s(raddr_s), rlen(rlen), dest_channel(dest_channel), is_by_channel(is_by_channel), reserved0(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const dm_load_act0_t &inst);

    struct dm_store_of_t : public gnne_instruction_t
    {
        opcode_t opcode;
        uint32_t tcu_id;
        uint32_t pu_id;
        gp_register_t raddr_d;
        shape_register_t rshape;
        act0_channel_t src_channel;
        uint32_t reserved0;

        dm_store_of_t(default_init_t) noexcept { }
        explicit dm_store_of_t(uint32_t tcu_id, uint32_t pu_id, gp_register_t raddr_d, shape_register_t rshape, act0_channel_t src_channel) noexcept
            : opcode(opcode_t::dm_store_of), tcu_id(tcu_id), pu_id(pu_id), raddr_d(raddr_d), rshape(rshape), src_channel(src_channel), reserved0(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const dm_store_of_t &inst);

    struct pu_fetchif_conf1_t : public gnne_instruction_t
    {
        opcode_t opcode;
        uint32_t tcu_id;
        uint32_t pu_id;
        pu_conf_function_t funct4;
        uint32_t stride_w;
        uint32_t stride_h;
        shape_register_t rstride_s;
        uint32_t reserved0;

        pu_fetchif_conf1_t(default_init_t) noexcept { }
        explicit pu_fetchif_conf1_t(uint32_t tcu_id, uint32_t pu_id, uint32_t stride_w, uint32_t stride_h, shape_register_t rstride_s) noexcept
            : opcode(opcode_t::pu_conf), tcu_id(tcu_id), pu_id(pu_id), funct4(pu_conf_function_t::pu_fetchif_conf1), stride_w(stride_w), stride_h(stride_h), rstride_s(rstride_s), reserved0(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const pu_fetchif_conf1_t &inst);

    struct pu_fetchif_conf2_t : public gnne_instruction_t
    {
        opcode_t opcode;
        uint32_t tcu_id;
        uint32_t pu_id;
        pu_conf_function_t funct4;
        gp_register_t rgic;
        gp_register_t rgic_last;
        uint32_t reserved0;

        pu_fetchif_conf2_t(default_init_t) noexcept { }
        explicit pu_fetchif_conf2_t(uint32_t tcu_id, uint32_t pu_id, gp_register_t rgic, gp_register_t rgic_last) noexcept
            : opcode(opcode_t::pu_conf), tcu_id(tcu_id), pu_id(pu_id), funct4(pu_conf_function_t::pu_fetchif_conf2), rgic(rgic), rgic_last(rgic_last), reserved0(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const pu_fetchif_conf2_t &inst);

    struct pu_fetchif_conf3_t : public gnne_instruction_t
    {
        opcode_t opcode;
        uint32_t tcu_id;
        uint32_t pu_id;
        pu_conf_function_t funct4;
        gp_register_t raddr_s;
        gp_register_t rgroups;
        shape_register_t rshape;
        uint32_t reserved0;

        pu_fetchif_conf3_t(default_init_t) noexcept { }
        explicit pu_fetchif_conf3_t(uint32_t tcu_id, uint32_t pu_id, gp_register_t raddr_s, gp_register_t rgroups, shape_register_t rshape) noexcept
            : opcode(opcode_t::pu_conf), tcu_id(tcu_id), pu_id(pu_id), funct4(pu_conf_function_t::pu_fetchif_conf3), raddr_s(raddr_s), rgroups(rgroups), rshape(rshape), reserved0(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const pu_fetchif_conf3_t &inst);

    struct pu_fetchif_conf4_t : public gnne_instruction_t
    {
        opcode_t opcode;
        uint32_t tcu_id;
        uint32_t pu_id;
        pu_conf_function_t funct4;
        gp_register_t rpad_value;
        uint32_t reserved0;
        shape_register_t sspad;
        uint32_t reserved1;

        pu_fetchif_conf4_t(default_init_t) noexcept { }
        explicit pu_fetchif_conf4_t(uint32_t tcu_id, uint32_t pu_id, gp_register_t rpad_value, shape_register_t sspad) noexcept
            : opcode(opcode_t::pu_conf), tcu_id(tcu_id), pu_id(pu_id), funct4(pu_conf_function_t::pu_fetchif_conf4), rpad_value(rpad_value), reserved0(0), sspad(sspad), reserved1(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const pu_fetchif_conf4_t &inst);

    struct pu_fetchif_conf_deq_t : public gnne_instruction_t
    {
        opcode_t opcode;
        uint32_t tcu_id;
        uint32_t pu_id;
        pu_conf_function_t funct4;
        int32_t ic;
        gp_register_t ric;
        gp_register_t rbx;
        quant_type_t quant_type;
        uint32_t reserved0;

        pu_fetchif_conf_deq_t(default_init_t) noexcept { }
        explicit pu_fetchif_conf_deq_t(uint32_t tcu_id, uint32_t pu_id, gp_register_t ric, gp_register_t rbx, quant_type_t quant_type) noexcept
            : opcode(opcode_t::pu_conf), tcu_id(tcu_id), pu_id(pu_id), funct4(pu_conf_function_t::pu_fetchif_conf_deq), ric(ric), rbx(rbx), quant_type(quant_type), reserved0(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const pu_fetchif_conf_deq_t &inst);

    struct pu_w_conf_t : public gnne_instruction_t
    {
        opcode_t opcode;
        uint32_t tcu_id;
        uint32_t pu_id;
        pu_conf_function_t funct4;
        uint32_t kernel_h;
        uint32_t kernel_w;
        uint32_t reserved0;

        pu_w_conf_t(default_init_t) noexcept { }
        explicit pu_w_conf_t(uint32_t tcu_id, uint32_t pu_id, uint32_t kernel_h, uint32_t kernel_w) noexcept
            : opcode(opcode_t::pu_conf), tcu_id(tcu_id), pu_id(pu_id), funct4(pu_conf_function_t::pu_w_conf), kernel_h(kernel_h), kernel_w(kernel_w), reserved0(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const pu_w_conf_t &inst);

    struct pu_of_conf1_t : public gnne_instruction_t
    {
        opcode_t opcode;
        uint32_t tcu_id;
        uint32_t pu_id;
        pu_conf_function_t funct4;
        gp_register_t rgoc;
        gp_register_t rgoc_last;
        shape_register_t rstride_d;
        uint32_t reserved0;

        pu_of_conf1_t(default_init_t) noexcept { }
        explicit pu_of_conf1_t(uint32_t tcu_id, uint32_t pu_id, gp_register_t rgoc, gp_register_t rgoc_last, shape_register_t rstride_d) noexcept
            : opcode(opcode_t::pu_conf), tcu_id(tcu_id), pu_id(pu_id), funct4(pu_conf_function_t::pu_of_conf1), rgoc(rgoc), rgoc_last(rgoc_last), rstride_d(rstride_d), reserved0(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const pu_of_conf1_t &inst);

    struct pu_of_conf2_t : public gnne_instruction_t
    {
        opcode_t opcode;
        uint32_t tcu_id;
        uint32_t pu_id;
        pu_conf_function_t funct4;
        gp_register_t raddr_d;
        uint32_t reserved0;
        shape_register_t rshape_d;
        uint32_t reserved1;

        pu_of_conf2_t(default_init_t) noexcept { }
        explicit pu_of_conf2_t(uint32_t tcu_id, uint32_t pu_id, gp_register_t raddr_d, shape_register_t rshape_d) noexcept
            : opcode(opcode_t::pu_conf), tcu_id(tcu_id), pu_id(pu_id), funct4(pu_conf_function_t::pu_of_conf2), raddr_d(raddr_d), reserved0(0), rshape_d(rshape_d), reserved1(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const pu_of_conf2_t &inst);

    struct pu_compute_conf_t : public gnne_instruction_t
    {
        opcode_t opcode;
        uint32_t tcu_id;
        uint32_t pu_id;
        pu_conf_function_t funct4;
        uint32_t load_psum;
        uint32_t clr_psum;
        pu_output_dest_t dest_target;
        uint32_t release_if;
        pu_compute_mode_t mode;
        uint32_t reserved0;

        pu_compute_conf_t(default_init_t) noexcept { }
        explicit pu_compute_conf_t(uint32_t tcu_id, uint32_t pu_id, uint32_t load_psum, uint32_t clr_psum, pu_output_dest_t dest_target, uint32_t release_if, pu_compute_mode_t mode) noexcept
            : opcode(opcode_t::pu_conf), tcu_id(tcu_id), pu_id(pu_id), funct4(pu_conf_function_t::pu_compute_conf), load_psum(load_psum), clr_psum(clr_psum), dest_target(dest_target), release_if(release_if), mode(mode), reserved0(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const pu_compute_conf_t &inst);

    struct pu_compute_t : public gnne_instruction_t
    {
        opcode_t opcode;
        uint32_t tcu_id;
        pu_of_shift_mode_t of_shift_mode;
        uint32_t reserved0;

        pu_compute_t(default_init_t) noexcept { }
        explicit pu_compute_t(uint32_t tcu_id, pu_of_shift_mode_t of_shift_mode) noexcept
            : opcode(opcode_t::pu_compute), tcu_id(tcu_id), of_shift_mode(of_shift_mode), reserved0(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const pu_compute_t &inst);

    struct pu_forward_psum_t : public gnne_instruction_t
    {
        opcode_t opcode;
        uint32_t tcu_id;
        uint32_t pu_id;
        gp_register_t raddr;
        gp_register_t rlen;
        uint32_t reserved0;

        pu_forward_psum_t(default_init_t) noexcept { }
        explicit pu_forward_psum_t(uint32_t tcu_id, uint32_t pu_id, gp_register_t raddr, gp_register_t rlen) noexcept
            : opcode(opcode_t::pu_forward_psum), tcu_id(tcu_id), pu_id(pu_id), raddr(raddr), rlen(rlen), reserved0(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const pu_forward_psum_t &inst);

    struct pu_pdp0_mode_conf_t : public gnne_instruction_t
    {
        opcode_t opcode;
        uint32_t tcu_id;
        uint32_t pu_id;
        pu_pdp0_conf_function_t funct4;
        pu_pdp0_mode_t mode;
        uint32_t reserved0;

        pu_pdp0_mode_conf_t(default_init_t) noexcept { }
        explicit pu_pdp0_mode_conf_t(uint32_t tcu_id, uint32_t pu_id, pu_pdp0_mode_t mode) noexcept
            : opcode(opcode_t::pu_pdp0_conf), tcu_id(tcu_id), pu_id(pu_id), funct4(pu_pdp0_conf_function_t::pdp0_mode_conf), mode(mode), reserved0(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const pu_pdp0_mode_conf_t &inst);

    struct pu_pdp0_fetchif_conf1_t : public gnne_instruction_t
    {
        opcode_t opcode;
        uint32_t tcu_id;
        uint32_t pu_id;
        pu_pdp0_conf_function_t funct4;
        uint32_t stride_w;
        uint32_t stride_h;
        uint32_t reserved0;

        pu_pdp0_fetchif_conf1_t(default_init_t) noexcept { }
        explicit pu_pdp0_fetchif_conf1_t(uint32_t tcu_id, uint32_t pu_id, uint32_t stride_w, uint32_t stride_h) noexcept
            : opcode(opcode_t::pu_pdp0_conf), tcu_id(tcu_id), pu_id(pu_id), funct4(pu_pdp0_conf_function_t::pdp0_fetchif_conf1), stride_w(stride_w), stride_h(stride_h), reserved0(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const pu_pdp0_fetchif_conf1_t &inst);

    struct pu_pdp0_fetchif_conf2_t : public gnne_instruction_t
    {
        opcode_t opcode;
        uint32_t tcu_id;
        uint32_t pu_id;
        pu_pdp0_conf_function_t funct4;
        gp_register_t rgic;
        gp_register_t rgic_last;
        uint32_t reserved0;

        pu_pdp0_fetchif_conf2_t(default_init_t) noexcept { }
        explicit pu_pdp0_fetchif_conf2_t(uint32_t tcu_id, uint32_t pu_id, gp_register_t rgic, gp_register_t rgic_last) noexcept
            : opcode(opcode_t::pu_pdp0_conf), tcu_id(tcu_id), pu_id(pu_id), funct4(pu_pdp0_conf_function_t::pdp0_fetchif_conf2), rgic(rgic), rgic_last(rgic_last), reserved0(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const pu_pdp0_fetchif_conf2_t &inst);

    struct pu_pdp0_fetchif_conf3_t : public gnne_instruction_t
    {
        opcode_t opcode;
        uint32_t tcu_id;
        uint32_t pu_id;
        pu_pdp0_conf_function_t funct4;
        uint32_t reserved0;
        shape_register_t rshape;
        uint32_t reserved1;

        pu_pdp0_fetchif_conf3_t(default_init_t) noexcept { }
        explicit pu_pdp0_fetchif_conf3_t(uint32_t tcu_id, uint32_t pu_id, shape_register_t rshape) noexcept
            : opcode(opcode_t::pu_pdp0_conf), tcu_id(tcu_id), pu_id(pu_id), funct4(pu_pdp0_conf_function_t::pdp0_fetchif_conf3), reserved0(0), rshape(rshape), reserved1(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const pu_pdp0_fetchif_conf3_t &inst);

    struct pu_pdp0_fetchif_conf4_t : public gnne_instruction_t
    {
        opcode_t opcode;
        uint32_t tcu_id;
        uint32_t pu_id;
        pu_pdp0_conf_function_t funct4;
        gp_register_t rpad_value;
        shape_register_t sspad;
        uint32_t reserved0;

        pu_pdp0_fetchif_conf4_t(default_init_t) noexcept { }
        explicit pu_pdp0_fetchif_conf4_t(uint32_t tcu_id, uint32_t pu_id, gp_register_t rpad_value, shape_register_t sspad) noexcept
            : opcode(opcode_t::pu_pdp0_conf), tcu_id(tcu_id), pu_id(pu_id), funct4(pu_pdp0_conf_function_t::pdp0_fetchif_conf4), rpad_value(rpad_value), sspad(sspad), reserved0(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const pu_pdp0_fetchif_conf4_t &inst);

    struct pu_pdp0_conf_deq_t : public gnne_instruction_t
    {
        opcode_t opcode;
        uint32_t tcu_id;
        uint32_t pu_id;
        pu_pdp0_conf_function_t funct4;
        gp_register_t rbx;
        quant_type_t quant_type;
        uint32_t reserved0;

        pu_pdp0_conf_deq_t(default_init_t) noexcept { }
        explicit pu_pdp0_conf_deq_t(uint32_t tcu_id, uint32_t pu_id, gp_register_t rbx, quant_type_t quant_type) noexcept
            : opcode(opcode_t::pu_pdp0_conf), tcu_id(tcu_id), pu_id(pu_id), funct4(pu_pdp0_conf_function_t::pdp0_fetchif_conf_deq), rbx(rbx), quant_type(quant_type), reserved0(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const pu_pdp0_conf_deq_t &inst);

    struct pu_pdp0_w_conf_t : public gnne_instruction_t
    {
        opcode_t opcode;
        uint32_t tcu_id;
        uint32_t pu_id;
        pu_pdp0_conf_function_t funct4;
        uint32_t kernel_h;
        uint32_t kernel_w;
        uint32_t reserved0;

        pu_pdp0_w_conf_t(default_init_t) noexcept { }
        explicit pu_pdp0_w_conf_t(uint32_t tcu_id, uint32_t pu_id, uint32_t kernel_h, uint32_t kernel_w) noexcept
            : opcode(opcode_t::pu_pdp0_conf), tcu_id(tcu_id), pu_id(pu_id), funct4(pu_pdp0_conf_function_t::pdp0_w_conf), kernel_h(kernel_h), kernel_w(kernel_w), reserved0(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const pu_pdp0_w_conf_t &inst);

    struct pu_pdp0_of_conf_t : public gnne_instruction_t
    {
        opcode_t opcode;
        uint32_t tcu_id;
        uint32_t pu_id;
        pu_pdp0_conf_function_t funct4;
        shape_register_t rstride_d;
        shape_register_t rshape_d;
        uint32_t reserved0;

        pu_pdp0_of_conf_t(default_init_t) noexcept { }
        explicit pu_pdp0_of_conf_t(uint32_t tcu_id, uint32_t pu_id, shape_register_t rstride_d, shape_register_t rshape_d) noexcept
            : opcode(opcode_t::pu_pdp0_conf), tcu_id(tcu_id), pu_id(pu_id), funct4(pu_pdp0_conf_function_t::pdp0_of_conf), rstride_d(rstride_d), rshape_d(rshape_d), reserved0(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const pu_pdp0_of_conf_t &inst);

    struct pu_pdp0_compute_t : public gnne_instruction_t
    {
        opcode_t opcode;
        uint32_t tcu_id;
        gp_register_t raddr_s;
        uint32_t reserved0;

        pu_pdp0_compute_t(default_init_t) noexcept { }
        explicit pu_pdp0_compute_t(uint32_t tcu_id, gp_register_t raddr_s) noexcept
            : opcode(opcode_t::pu_pdp0_compute), tcu_id(tcu_id), raddr_s(raddr_s), reserved0(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const pu_pdp0_compute_t &inst);

    struct act0_src1_conf_t : public gnne_instruction_t
    {
        opcode_t opcode;
        uint32_t tcu_id;
        uint32_t pu_id;
        act0_conf_function_t funct3;
        act0_channel_t channel;
        shape_register_t rshape;
        uint32_t rshift_bits;
        uint32_t reserved0;

        act0_src1_conf_t(default_init_t) noexcept { }
        explicit act0_src1_conf_t(uint32_t tcu_id, uint32_t pu_id, act0_channel_t channel, shape_register_t rshape, uint32_t rshift_bits) noexcept
            : opcode(opcode_t::act0_conf), tcu_id(tcu_id), pu_id(pu_id), funct3(act0_conf_function_t::act_src1_conf), channel(channel), rshape(rshape), rshift_bits(rshift_bits), reserved0(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const act0_src1_conf_t &inst);

    struct act0_compute_t : public gnne_instruction_t
    {
        opcode_t opcode;
        uint32_t reserved0;
        gp_register_t raddr_d;
        uint32_t tcu_id;
        act0_channel_t channel;
        act0_output_dest_t target;
        act_output_type_t dest_datatype;
        uint32_t is_by_channel;
        uint32_t reserved1;

        act0_compute_t(default_init_t) noexcept { }
        explicit act0_compute_t(gp_register_t raddr_d, uint32_t tcu_id, act0_channel_t channel, act0_output_dest_t target, act_output_type_t dest_datatype, uint32_t is_by_channel) noexcept
            : opcode(opcode_t::act0_compute), reserved0(0), raddr_d(raddr_d), tcu_id(tcu_id), channel(channel), target(target), dest_datatype(dest_datatype), is_by_channel(is_by_channel), reserved1(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const act0_compute_t &inst);

    struct mfu_memcpy_t : public gnne_instruction_t
    {
        opcode_t opcode;
        gp_register_t raddr_d;
        gp_register_t raddr_s;
        shape_register_t rstride_d;
        shape_register_t rstride_s;
        shape_register_t rshape;
        uint32_t reserved0;

        mfu_memcpy_t(default_init_t) noexcept { }
        explicit mfu_memcpy_t(gp_register_t raddr_d, gp_register_t raddr_s, shape_register_t rstride_d, shape_register_t rstride_s, shape_register_t rshape) noexcept
            : opcode(opcode_t::mfu_memcpy), raddr_d(raddr_d), raddr_s(raddr_s), rstride_d(rstride_d), rstride_s(rstride_s), rshape(rshape), reserved0(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const mfu_memcpy_t &inst);

    struct mfu_memset_t : public gnne_instruction_t
    {
        opcode_t opcode;
        gp_register_t raddr_d;
        gp_register_t rv;
        shape_register_t rstride;
        shape_register_t rshape;
        l2_datatype_t l2_datatype;
        uint32_t reserved0;

        mfu_memset_t(default_init_t) noexcept { }
        explicit mfu_memset_t(gp_register_t raddr_d, gp_register_t rv, shape_register_t rstride, shape_register_t rshape, l2_datatype_t l2_datatype) noexcept
            : opcode(opcode_t::mfu_memset), raddr_d(raddr_d), rv(rv), rstride(rstride), rshape(rshape), l2_datatype(l2_datatype), reserved0(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const mfu_memset_t &inst);

    struct mfu_transpose_conf_t : public gnne_instruction_t
    {
        opcode_t opcode;
        mfu_conf_function_t funct5;
        shape_register_t rstride_d;
        shape_register_t rstride_s;
        l2_datatype_t l2_datatype;
        mfu_trans_permute_t permute;
        uint32_t reserved0;

        mfu_transpose_conf_t(default_init_t) noexcept { }
        explicit mfu_transpose_conf_t(shape_register_t rstride_d, shape_register_t rstride_s, l2_datatype_t l2_datatype, mfu_trans_permute_t permute) noexcept
            : opcode(opcode_t::mfu_conf), funct5(mfu_conf_function_t::transpose_conf), rstride_d(rstride_d), rstride_s(rstride_s), l2_datatype(l2_datatype), permute(permute), reserved0(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const mfu_transpose_conf_t &inst);

    struct mfu_transpose_t : public gnne_instruction_t
    {
        opcode_t opcode;
        gp_register_t raddr_d;
        gp_register_t raddr_s;
        shape_register_t rshape;
        uint32_t reserved0;

        mfu_transpose_t(default_init_t) noexcept { }
        explicit mfu_transpose_t(gp_register_t raddr_d, gp_register_t raddr_s, shape_register_t rshape) noexcept
            : opcode(opcode_t::mfu_transpose), raddr_d(raddr_d), raddr_s(raddr_s), rshape(rshape), reserved0(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const mfu_transpose_t &inst);

    struct mfu_pdp1_conf1_t : public gnne_instruction_t
    {
        opcode_t opcode;
        mfu_conf_function_t funct5;
        uint32_t stride_w;
        uint32_t stride_h;
        shape_register_t rstride_s;
        pdp_function_t funct2;
        shape_register_t rstride_d;
        uint32_t reserved0;

        mfu_pdp1_conf1_t(default_init_t) noexcept { }
        explicit mfu_pdp1_conf1_t(uint32_t stride_w, uint32_t stride_h, shape_register_t rstride_s, pdp_function_t funct2, shape_register_t rstride_d) noexcept
            : opcode(opcode_t::mfu_conf), funct5(mfu_conf_function_t::pdp1_conf1), stride_w(stride_w), stride_h(stride_h), rstride_s(rstride_s), funct2(funct2), rstride_d(rstride_d), reserved0(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const mfu_pdp1_conf1_t &inst);

    struct mfu_pdp1_conf2_t : public gnne_instruction_t
    {
        opcode_t opcode;
        mfu_conf_function_t funct5;
        gp_register_t rcount_w;
        gp_register_t rcount_h;
        gp_register_t rpe_h;
        gp_register_t rpe_last_h;

        mfu_pdp1_conf2_t(default_init_t) noexcept { }
        explicit mfu_pdp1_conf2_t(gp_register_t rcount_w, gp_register_t rcount_h, gp_register_t rpe_h, gp_register_t rpe_last_h) noexcept
            : opcode(opcode_t::mfu_conf), funct5(mfu_conf_function_t::pdp1_conf2), rcount_w(rcount_w), rcount_h(rcount_h), rpe_h(rpe_h), rpe_last_h(rpe_last_h)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const mfu_pdp1_conf2_t &inst);

    struct mfu_pdp1_conf3_t : public gnne_instruction_t
    {
        opcode_t opcode;
        mfu_conf_function_t funct5;
        gp_register_t rpe_channels;
        gp_register_t rpe_last_channels;
        gp_register_t rpad_value;
        shape_register_t sspad;
        uint32_t reserved0;

        mfu_pdp1_conf3_t(default_init_t) noexcept { }
        explicit mfu_pdp1_conf3_t(gp_register_t rpe_channels, gp_register_t rpe_last_channels, gp_register_t rpad_value, shape_register_t sspad) noexcept
            : opcode(opcode_t::mfu_conf), funct5(mfu_conf_function_t::pdp1_conf3), rpe_channels(rpe_channels), rpe_last_channels(rpe_last_channels), rpad_value(rpad_value), sspad(sspad), reserved0(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const mfu_pdp1_conf3_t &inst);

    struct mfu_pdp1_conf4_t : public gnne_instruction_t
    {
        opcode_t opcode;
        mfu_conf_function_t funct5;
        gp_register_t rwindow_w;
        gp_register_t rwindow_h;
        gp_register_t rscale;
        uint32_t enable_h2c;
        uint32_t enable_bw;
        uint32_t reserved0;

        mfu_pdp1_conf4_t(default_init_t) noexcept { }
        explicit mfu_pdp1_conf4_t(gp_register_t rwindow_w, gp_register_t rwindow_h, gp_register_t rscale, uint32_t enable_h2c, uint32_t enable_bw) noexcept
            : opcode(opcode_t::mfu_conf), funct5(mfu_conf_function_t::pdp1_conf4), rwindow_w(rwindow_w), rwindow_h(rwindow_h), rscale(rscale), enable_h2c(enable_h2c), enable_bw(enable_bw), reserved0(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const mfu_pdp1_conf4_t &inst);

    struct mfu_pdp1_conf_deq_t : public gnne_instruction_t
    {
        opcode_t opcode;
        mfu_conf_function_t funct5;
        gp_register_t rscale;
        gp_register_t rbias;
        quant_type_t quant_type;
        uint32_t rshift_bits;
        uint32_t reserved0;

        mfu_pdp1_conf_deq_t(default_init_t) noexcept { }
        explicit mfu_pdp1_conf_deq_t(gp_register_t rscale, gp_register_t rbias, quant_type_t quant_type, uint32_t rshift_bits) noexcept
            : opcode(opcode_t::mfu_conf), funct5(mfu_conf_function_t::pdp1_conf_deq), rscale(rscale), rbias(rbias), quant_type(quant_type), rshift_bits(rshift_bits), reserved0(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const mfu_pdp1_conf_deq_t &inst);

    struct mfu_pdp1_conf_quant_t : public gnne_instruction_t
    {
        opcode_t opcode;
        mfu_conf_function_t funct5;
        gp_register_t rscale;
        gp_register_t rbias;
        quant_type_t quant_type;
        uint32_t rshift_bits;
        uint32_t reserved0;

        mfu_pdp1_conf_quant_t(default_init_t) noexcept { }
        explicit mfu_pdp1_conf_quant_t(gp_register_t rscale, gp_register_t rbias, quant_type_t quant_type, uint32_t rshift_bits) noexcept
            : opcode(opcode_t::mfu_conf), funct5(mfu_conf_function_t::pdp1_conf_quant), rscale(rscale), rbias(rbias), quant_type(quant_type), rshift_bits(rshift_bits), reserved0(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const mfu_pdp1_conf_quant_t &inst);

    struct mfu_pdp1_compute_t : public gnne_instruction_t
    {
        opcode_t opcode;
        gp_register_t raddr_d;
        gp_register_t raddr_s;
        shape_register_t rshape;
        uint32_t reserved1;

        mfu_pdp1_compute_t(default_init_t) noexcept { }
        explicit mfu_pdp1_compute_t(gp_register_t raddr_d, gp_register_t raddr_s, shape_register_t rshape) noexcept
            : opcode(opcode_t::mfu_pdp1_compute), raddr_d(raddr_d), raddr_s(raddr_s), rshape(rshape), reserved1(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const mfu_pdp1_compute_t &inst);

    struct mfu_act1_conf_stride_t : public gnne_instruction_t
    {
        opcode_t opcode;
        mfu_conf_function_t funct5;
        shape_register_t rstride_s1;
        shape_register_t rstride_s2;
        shape_register_t rstride_d1;
        uint32_t reserved0;

        mfu_act1_conf_stride_t(default_init_t) noexcept { }
        explicit mfu_act1_conf_stride_t(shape_register_t rstride_s1, shape_register_t rstride_s2, shape_register_t rstride_d1) noexcept
            : opcode(opcode_t::mfu_conf), funct5(mfu_conf_function_t::act1_conf_stride), rstride_s1(rstride_s1), rstride_s2(rstride_s2), rstride_d1(rstride_d1), reserved0(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const mfu_act1_conf_stride_t &inst);

    struct mfu_act1_conf_src1_t : public gnne_instruction_t
    {
        opcode_t opcode;
        mfu_conf_function_t funct5;
        gp_register_t rslice;
        gp_register_t rright_repeats;
        gp_register_t rslice_repeats;
        uint32_t sid;
        uint32_t slice_loc;
        uint32_t reserved0;

        mfu_act1_conf_src1_t(default_init_t) noexcept { }
        explicit mfu_act1_conf_src1_t(gp_register_t rslice, gp_register_t rright_repeats, gp_register_t rslice_repeats, uint32_t sid, uint32_t slice_loc) noexcept
            : opcode(opcode_t::mfu_conf), funct5(mfu_conf_function_t::act1_conf_src1), rslice(rslice), rright_repeats(rright_repeats), rslice_repeats(rslice_repeats), sid(sid), slice_loc(slice_loc), reserved0(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const mfu_act1_conf_src1_t &inst);

    struct mfu_act1_conf_src2_t : public gnne_instruction_t
    {
        opcode_t opcode;
        mfu_conf_function_t funct5;
        gp_register_t rleft_repeats;
        shape_register_t rshape;
        uint32_t sid;
        act1_source_type_t source_type;
        uint32_t reserved0;

        mfu_act1_conf_src2_t(default_init_t) noexcept { }
        explicit mfu_act1_conf_src2_t(gp_register_t rleft_repeats, shape_register_t rshape, uint32_t sid, act1_source_type_t source_type) noexcept
            : opcode(opcode_t::mfu_conf), funct5(mfu_conf_function_t::act1_conf_src2), rleft_repeats(rleft_repeats), rshape(rshape), sid(sid), source_type(source_type), reserved0(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const mfu_act1_conf_src2_t &inst);

    struct mfu_act1_conf_dest_t : public gnne_instruction_t
    {
        opcode_t opcode;
        mfu_conf_function_t funct5;
        gp_register_t rlen;
        shape_register_t rshape;
        uint32_t reserved0;

        mfu_act1_conf_dest_t(default_init_t) noexcept { }
        explicit mfu_act1_conf_dest_t(gp_register_t rlen, shape_register_t rshape) noexcept
            : opcode(opcode_t::mfu_conf), funct5(mfu_conf_function_t::act1_conf_dest), rlen(rlen), rshape(rshape), reserved0(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const mfu_act1_conf_dest_t &inst);

    struct mfu_act1_conf_deq_t : public gnne_instruction_t
    {
        opcode_t opcode;
        mfu_conf_function_t funct5;
        gp_register_t rscale;
        gp_register_t rbias;
        quant_type_t quant_type;
        uint32_t sid;
        uint32_t rshift_bits;
        uint32_t reserved0;

        mfu_act1_conf_deq_t(default_init_t) noexcept { }
        explicit mfu_act1_conf_deq_t(gp_register_t rscale, gp_register_t rbias, quant_type_t quant_type, uint32_t sid, uint32_t rshift_bits) noexcept
            : opcode(opcode_t::mfu_conf), funct5(mfu_conf_function_t::act1_conf_deq), rscale(rscale), rbias(rbias), quant_type(quant_type), sid(sid), rshift_bits(rshift_bits), reserved0(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const mfu_act1_conf_deq_t &inst);

    struct mfu_act1_conf_quant_t : public gnne_instruction_t
    {
        opcode_t opcode;
        mfu_conf_function_t funct5;
        quant_type_t quant_type;
        uint32_t rshift_bits;
        uint32_t reserved0;

        mfu_act1_conf_quant_t(default_init_t) noexcept { }
        explicit mfu_act1_conf_quant_t(quant_type_t quant_type, uint32_t rshift_bits) noexcept
            : opcode(opcode_t::mfu_conf), funct5(mfu_conf_function_t::act1_conf_quant), quant_type(quant_type), rshift_bits(rshift_bits), reserved0(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const mfu_act1_conf_quant_t &inst);

    struct mfu_act1_conf_t : public gnne_instruction_t
    {
        opcode_t opcode;
        mfu_conf_function_t funct5;
        mfu_act1_function_t funct4;
        uint32_t is_by_channel;
        uint32_t is_16_segments;
        uint32_t reserved0;

        mfu_act1_conf_t(default_init_t) noexcept { }
        explicit mfu_act1_conf_t(mfu_act1_function_t funct4, uint32_t is_by_channel, uint32_t is_16_segments) noexcept
            : opcode(opcode_t::mfu_conf), funct5(mfu_conf_function_t::act1_conf), funct4(funct4), is_by_channel(is_by_channel), is_16_segments(is_16_segments), reserved0(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const mfu_act1_conf_t &inst);

    struct mfu_act1_compute_t : public gnne_instruction_t
    {
        opcode_t opcode;
        gp_register_t raddr_d1;
        gp_register_t raddr_s1;
        gp_register_t raddr_s2;
        gp_register_t raddr_arg;
        uint32_t reserved0;

        mfu_act1_compute_t(default_init_t) noexcept { }
        explicit mfu_act1_compute_t(gp_register_t raddr_d1, gp_register_t raddr_s1, gp_register_t raddr_s2, gp_register_t raddr_arg) noexcept
            : opcode(opcode_t::mfu_act1_compute), raddr_d1(raddr_d1), raddr_s1(raddr_s1), raddr_s2(raddr_s2), raddr_arg(raddr_arg), reserved0(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const mfu_act1_compute_t &inst);

    struct extrw_t : public gnne_instruction_t
    {
        opcode_t opcode;
        uint32_t extrd;
        gp_register_t rs;
        uint32_t imm;

        extrw_t(default_init_t) noexcept { }
        explicit extrw_t(uint32_t extrd, gp_register_t rs, uint32_t imm) noexcept
            : opcode(opcode_t::extrw), extrd(extrd), rs(rs), imm(imm)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const extrw_t &inst);

    struct extraw_t : public gnne_instruction_t
    {
        opcode_t opcode;
        uint32_t extrd;
        gp_register_t rs;
        uint32_t imm;

        extraw_t(default_init_t) noexcept { }
        explicit extraw_t(uint32_t extrd, gp_register_t rs, uint32_t imm) noexcept
            : opcode(opcode_t::extraw), extrd(extrd), rs(rs), imm(imm)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const extraw_t &inst);

    struct ai2d_compute_t : public gnne_instruction_t
    {
        opcode_t opcode;
        uint32_t reserved0;

        ai2d_compute_t(default_init_t) noexcept { }
        explicit ai2d_compute_t() noexcept
            : opcode(opcode_t::ai2d_compute), reserved0(0)
        {
        }

        opcode_t op_code() const override { return opcode; }

        void serialize(binary_writer &writer) const override;

        void to_string(std::ostream &out) const override;
    };

    std::ostream &operator<<(std::ostream &out, const ai2d_compute_t &inst);
}
}